enum EnvType {
  dev,
  staging,
  prod;

  static EnvType fromString(String value) =>
      EnvType.values.firstWhere((e) => e.name == value.toLowerCase().trim());

  static EnvType? fromStringOr(String value, {EnvType? or}) {
    try {
      return EnvType.values
          .firstWhere((e) => e.name == value.toLowerCase().trim());
    } catch (_) {
      return or;
    }
  }
}
