import 'package:logging/logging.dart';

abstract class LogLevel {
  static const Level verbose = Level('VERBOSE', 300);
  static const Level bloc = Level('BLOC', 450);
  static const Level debug = Level('DEBUG', 500);
  static const Level info = Level.INFO;
  static const Level warn = Level.WARNING;
  static const Level error = Level('ERROR', 1000);

  static Level fromString(String value) => switch (value.toLowerCase()) {
        'verbose' => verbose,
        'bloc' => bloc,
        'debug' => debug,
        'info' => info,
        'warn' || 'warning' => warn,
        'error' || 'fail' || 'failure' => error,
        _ => throw Exception('Unknown log level: $value'),
      };
}
