import 'package:logging/logging.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/core/logger/app_logger_plugin.dart';

class SimpleLogPrinter implements AppLoggerPlugin {
  const SimpleLogPrinter();

  /// Formats [LogRecord] using level, namespace, and message components.
  static String formatLogRecord(LogRecord record) {
    final buffer = StringBuffer()
      ..write(record.level.name.toUpperCase())
      ..write(' | ');

    final namespace = record.loggerName.split('.').lastOrNull;
    if (namespace != null && namespace.isNotEmpty) {
      buffer
        ..write(namespace)
        ..write(' | ');
    }

    buffer.write(record.message);
    final error = record.error;
    if (error != null) {
      buffer
        ..write(': ')
        ..writeln(error);
    }
    final stackTrace = record.stackTrace;
    if (stackTrace != null) {
      buffer.writeln(stackTrace);
    }

    return buffer.toString();
  }

  @override
  void handleLogRecord(LogRecord record) {
    // ignore: avoid_print
    print(formatLogRecord(record));
  }
}
